#ifndef TASK1_SOLUTION_HPP
#define TASK1_SOLUTION_HPP

#include <utility>

/// Namespace aimed to avoid possible name resolution conflicts
namespace my {
    void fillIntegerArray(int *begin, int *end, int value);
    void fillCharacterArray(char *begin, char *end, char value);
    void copyIntegerArray(int *src_begin, int *src_end, int *dest);
    std::pair<int*,std::size_t> copyEvenElements(int *src, std::size_t src_size);
    int* relocateIntegerArray(int *src, std::size_t size, std::size_t newsize);
    int sumIntegerArray(int *begin, int *end, std::size_t stride=1);
    float integerArrayMean(int *begin, int *end, std::size_t stride=1);
    int findFirstElement(int *begin, int *end, int target);
    int findLastElement(int *begin, int *end, int target);
    bool stringIsSafeToPrint(char *begin, char *end);
    bool isPalindrome(char *begin, char *end);
    bool isPalindrome2(char* str);
    void deleteCharacter(char *str, unsigned int idx);
    void insertCharacter(char *str, char character, unsigned int idx);
    void insertCharacters(char *dest_str, char *src_str, unsigned int idx);
}

#endif
